<a name="__pageTop"></a>
# AdminApi   { #AdminApi }


All URIs are relative to *https://git.euph.dev/api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**admin_get_authenticated**](#admin_get_authenticated) | **GET** `/admin/authenticated` | 
[**get_all_players**](#get_all_players) | **POST** `/admin/players` | Retrieve a paginated list of players

# **admin_get_authenticated**   { #admin_get_authenticated }
<a name="admin_get_authenticated"></a>

> `admin_get_authenticated( on_success: Callable, on_failure: Callable)`



Endpoint for Checking if you're authenticated as an admin

### Example

* Bearer (JWT) Authentication (`JWTAuth`)

```gdscript

# Customize configuration
var config := ApiConfig.new()
config.host = "localhost"
config.port = 8080
#config.tls_enabled = true
#config.trusted_chain = preload("res://my_cert_chain.crt")

# Instantiate the api
var api = AdminApi.new(config)
# You can also provide your own HTTPClient, to re-use it across apis.
#var api = AdminApi.new(config, client)


# Invoke an endpoint
api.admin_get_authenticated(
	# On Success
	func(response):  # response is ApiResponse
		prints("Success!", "admin_get_authenticated", response)
		assert(response.data is AdminAuthInfo)
		pass  # do things, make stuff
		,
	# On Error
	func(error):  # error is ApiError
		push_error(str(error))
		,
)

```

# **get_all_players**   { #get_all_players }
<a name="get_all_players"></a>

> `get_all_players(playerFilter = null, on_success: Callable, on_failure: Callable)`

Retrieve a paginated list of players

Returns a paginat#ed list of players, optionally filtered by username.

### Example

* Bearer (JWT) Authentication (`JWTAuth`)

```gdscript

# Customize configuration
var config := ApiConfig.new()
config.host = "localhost"
config.port = 8080
#config.tls_enabled = true
#config.trusted_chain = preload("res://my_cert_chain.crt")

# Instantiate the api
var api = AdminApi.new(config)
# You can also provide your own HTTPClient, to re-use it across apis.
#var api = AdminApi.new(config, client)

var playerFilter = PlayerFilter.new()
# … fill model playerFilter with data

# Invoke an endpoint
api.get_all_players(
	# playerFilter: PlayerFilter
	playerFilter,
	# On Success
	func(response):  # response is ApiResponse
		prints("Success!", "get_all_players", response)
		assert(response.data is AdministratablePlayer)
		pass  # do things, make stuff
		,
	# On Error
	func(error):  # error is ApiError
		push_error(str(error))
		,
)

```


### Authorization

[JWTAuth](../README.md#JWTAuth)

[[Back to top]](#__pageTop) \
[[Back to API list]](../README.md#documentation-for-api-endpoints) \
[[Back to Model list]](../README.md#documentation-for-models) \
[[Back to README]](../README.md) \

