<a name="__pageTop"></a>
# ServerApi   { #ServerApi }


All URIs are relative to *https://git.euph.dev/api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**player_login**](#player_login) | **POST** `/player/login` | 
[**player_register**](#player_register) | **POST** `/player/register` | 
[**server_get_healthcheck**](#server_get_healthcheck) | **GET** `/server/health` | 

# **player_login**   { #player_login }
<a name="player_login"></a>

> `player_login(playerLoginData = null, on_success: Callable, on_failure: Callable)`



Endpoint for logging a Player in

### Example

* Bearer (JWT) Authentication (`JWTAuth`)

```gdscript

# Customize configuration
var config := ApiConfig.new()
config.host = "localhost"
config.port = 8080
#config.tls_enabled = true
#config.trusted_chain = preload("res://my_cert_chain.crt")

# Instantiate the api
var api = ServerApi.new(config)
# You can also provide your own HTTPClient, to re-use it across apis.
#var api = ServerApi.new(config, client)

var playerLoginData = PlayerLoginData.new()
# … fill model playerLoginData with data

# Invoke an endpoint
api.player_login(
	# playerLoginData: PlayerLoginData
	playerLoginData,
	# On Success
	func(response):  # response is ApiResponse
		prints("Success!", "player_login", response)
		assert(response.data is PlayerLoginSession)
		pass  # do things, make stuff
		,
	# On Error
	func(error):  # error is ApiError
		push_error(str(error))
		,
)

```

# **player_register**   { #player_register }
<a name="player_register"></a>

> `player_register(playerRegistrationData = null, on_success: Callable, on_failure: Callable)`



Endpoint for registering a new Player

### Example

* Bearer (JWT) Authentication (`JWTAuth`)

```gdscript

# Customize configuration
var config := ApiConfig.new()
config.host = "localhost"
config.port = 8080
#config.tls_enabled = true
#config.trusted_chain = preload("res://my_cert_chain.crt")

# Instantiate the api
var api = ServerApi.new(config)
# You can also provide your own HTTPClient, to re-use it across apis.
#var api = ServerApi.new(config, client)

var playerRegistrationData = PlayerRegistrationData.new()
# … fill model playerRegistrationData with data

# Invoke an endpoint
api.player_register(
	# playerRegistrationData: PlayerRegistrationData
	playerRegistrationData,
	# On Success
	func(response):
		prints("Success!", "player_register", response)
		
		pass  # do things, make stuff
		,
	# On Error
	func(error):  # error is ApiError
		push_error(str(error))
		,
)

```

# **server_get_healthcheck**   { #server_get_healthcheck }
<a name="server_get_healthcheck"></a>

> `server_get_healthcheck( on_success: Callable, on_failure: Callable)`



Endpoint for doing a Healthcheck of the Server

### Example

* Bearer (JWT) Authentication (`JWTAuth`)

```gdscript

# Customize configuration
var config := ApiConfig.new()
config.host = "localhost"
config.port = 8080
#config.tls_enabled = true
#config.trusted_chain = preload("res://my_cert_chain.crt")

# Instantiate the api
var api = ServerApi.new(config)
# You can also provide your own HTTPClient, to re-use it across apis.
#var api = ServerApi.new(config, client)


# Invoke an endpoint
api.server_get_healthcheck(
	# On Success
	func(response):  # response is ApiResponse
		prints("Success!", "server_get_healthcheck", response)
		assert(response.data is ServerHealth)
		pass  # do things, make stuff
		,
	# On Error
	func(error):  # error is ApiError
		push_error(str(error))
		,
)

```


### Authorization

[JWTAuth](../README.md#JWTAuth)

[[Back to top]](#__pageTop) \
[[Back to API list]](../README.md#documentation-for-api-endpoints) \
[[Back to Model list]](../README.md#documentation-for-models) \
[[Back to README]](../README.md) \

